% lab06_ex_dft_zoom.m - FFT zooming via appending zeros to the signal end
clear all; close all;

N=20; K=25; fs=100;     % FFT length, resolution increase, sampling frequency
dt=1/fs; t=dt*(0:N-1);  % sampling period, sampling time moments
x = sin(2*pi*22*t);     % signal
w = rectwin(N)';        % window: rectwin(), hanning(), blackman(), flattopwin(),..
x = x.*w;               % signal windowing
X = fft(x)/sum(w);      % FFT without appending zeros
Xz = fft( [x,zeros(1,(K-1)*N)] )/sum(w);      % with zeros; Xz = fft(x,K*N)/N;
f = fs/N *(0:N-1); fz = fs/(K*N)*(0:K*N-1);   % frequency axis
plot(f,abs(X),'ro',fz,abs(Xz),'b.','MarkerFaceColor','r'); xlabel('f (Hz)');
title('Zoomed DFT via FFT (20 or 22 Hz)'); grid; pause
